#include "Cover.h"

using namespace std;

extern std::vector< boost::dynamic_bitset<> > Vertical_DataBase;

/// Compute initial cover (all transaction)
void Cover::Initial_Cover(VECELE t_value_0){ 	
	for (unsigned int i = 0; i < Vertical_DataBase[0].size(); i++) {		
		if ( t_value_0[i] != 0 ) // if the transaction is valid
			Liste_Cover.push_back(i); // all "id" of transactions		 
  }    
}

/// Compute cover incrementaly using previous covers
void Cover::Compute_New_Cover(VECELE item_prefix, VECELE t_value_0, Cover *nextCover){  
		
	for (unsigned int i = 0; i < Liste_Cover.size(); i++){ // For each transaction of Cover 		
		if ( t_value_0[Liste_Cover[i]] != 0 ){ // if the transaction is valid
			int flag = 1;
			for(int j=0; ((j<item_prefix.size()) && (flag==1) ); j++) { // new item(s) of sigma_1
				if (Vertical_DataBase[item_prefix[j]-1][Liste_Cover[i]] == 0 ) { // if an item isn't in transaction => don't take the transaction
					flag = 0;
					break;		
				}
			}
			if (flag == 1) // transaction include the item
				nextCover->Liste_Cover.push_back(Liste_Cover[i]);	// add this id's transation to new cover			
		}  
	}
}

/// Compute inclusions test : case p_k = 0 && sum = 0
void Cover::Inclusion_test_00(VECELE t_value_0, VECELE sigma_0_new, VECELE sigma_01){
	bool dominer = true; // flag
	Inclusion.clear(); // clean at each call, because it's the same object, we don't compute a new cover when p_k = 0
	
	int sigma_0_new_size = sigma_0_new.size();
	int sigma_01_size = sigma_01.size();
	for (unsigned int i = 0; i < sigma_0_new_size; i++){
		for (unsigned int j = 0; j < sigma_01_size; j++){
			dominer = true;	 // i domine j jusqu'a preuve du contraire			
			for (unsigned int k = 0; k < Vertical_DataBase[0].size(); k++){ // for each id in cover (here the cover is initial)	
				if ( t_value_0[k] != 0 ){ 	// if t is valid
					// if  (i = 0 && j = 1) => j isn't included in i					
					if ((( Vertical_DataBase[sigma_0_new[i]-1][k] == 0) && ( Vertical_DataBase[sigma_01[j]-1][k] == 1))){
						dominer = false;
						break;	// sortir de la boucle sur les transactions	
					}	
				}										
			}
			if(dominer){
				Inclusion.push_back(sigma_01[j]); // Add this item
				sigma_0_new.push_back(sigma_01[j]); // Update sigma_0 en y ajoutant l'item j	
				// Update sigma_01 en y retirant l'item i
				if (find(sigma_01.begin(), sigma_01.end(), sigma_01[j]) == sigma_01.end()){ 
					sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), sigma_01[j]), sigma_01.end());
					break;
				}		
				sigma_0_new_size++;
				sigma_01_size--;
			}					
		}										
	}
}

/// Compute : (no frequent items) + (full extension items) + (items included in items of sigma_0)
void Cover::Frequent_Closed_Itemsets(VECELE t_value_0, VECELE p_value_0, int minF, VECELE sigma_1, VECELE sigma_0, VECELE sigma_01){
	
	int sigma_0_size = sigma_0.size();
	int sigma_01_size = sigma_01.size();
	int Somme_V_j, Somme_V_i = 0;	
	bool dominer = true;
	
	//----------------------------------------------------------
	// Update Frequency + Get Not Frequents Items + Closure Operation
	//----------------------------------------------------------
	for (unsigned int i = 0; i < Vertical_DataBase.size(); i++){
		
		Frequency.push_back(0);
		if ( p_value_0[i] != 0 ){ // only valid items
			// Consider only items in sigma_01 and sigma_0
			if (find(sigma_1.begin(), sigma_1.end(), i+1) == sigma_1.end()){ 
				// Compute frequency of item 'i'
				for (unsigned int j = 0; j < Liste_Cover.size(); j++){	// for each id in cover
					Frequency[i] += Vertical_DataBase[i][Liste_Cover[j]];
				}
				// items with frequency = |P| (full extension) add to Closure set
				if (Frequency[i] == Liste_Cover.size()){
					Closure.push_back(i+1);					
					sigma_1.push_back(i+1); // Update sigma_1
											
				}
				// items with frequency < minSup => add to NotFreqIt set
				else if ( Frequency[i] < minF ){
					NotFreqItems.push_back(i+1);				
					sigma_0.push_back(i+1); // Update
					
				}
			}		 
		}
	}
	
	//--- V2 : version avec boucles inversées ---//
	for (unsigned int i = 0; i < sigma_0_size; i++){
		for (unsigned int j = 0; j < sigma_01_size; j++){
			// if the frequency of items (i,j) are >= minsup and que freq_j >= freq_i => look for inclusion (j => i)
			if ((Frequency[sigma_0[i]-1] >= minF) && (Frequency[sigma_01[j]-1] >= minF) && (Frequency[sigma_0[i]-1] >= Frequency[sigma_01[j]-1])){
				Somme_V_j, Somme_V_i = 0;
				dominer = true;	 	
				for (unsigned int k = 0; k < Liste_Cover.size(); k++){ // for each id in cover (here the cover is initial)	
					if ( t_value_0[k] != 0 ){ 	// if t is valid
						Somme_V_i += Vertical_DataBase[sigma_0[i]-1][Liste_Cover[k]]; // |V_i| 
						Somme_V_j += Vertical_DataBase[sigma_01[j]-1][Liste_Cover[k]];  // |V_j|	
						// if  (i = 0 && j = 1) => j isn't included in i	
						if ((( Vertical_DataBase[sigma_0[i]-1][Liste_Cover[k]] == 0) && ( Vertical_DataBase[sigma_01[j]-1][Liste_Cover[k]] == 1)) ||
						((Somme_V_i == Frequency[sigma_0[i]-1]) && (Somme_V_j < Frequency[sigma_01[j]-1]))){
							dominer = false;
							break;	// sortir de la boucle sur les transactions	
						}	
					}										
				}
				if(dominer){
					Inclusion.push_back(sigma_01[j]); // Add this item
					sigma_0.push_back(sigma_01[j]); // Update sigma_0 en y ajoutant l'item j	
					// Update sigma_01 en y retirant l'item i
					if (find(sigma_01.begin(), sigma_01.end(), sigma_01[j]) == sigma_01.end()){ 
						sigma_01.erase(std::remove(sigma_01.begin(), sigma_01.end(), sigma_01[j]), sigma_01.end());
						break;
					}				
					sigma_0_size++;
					sigma_01_size--;
				}					
			}										
		}
	}	
}
