#include "DataBases.h"

using namespace std;

/// Parse database file on initial_DataBase structure
void DataBases::GetData(string FileName){
	ifstream fichier(FileName.c_str(), ios::in); 
	vector <int> Temporary_Transaction;
	string ligne; 		  
	if (fichier){					
		while (getline(fichier, ligne)){ 
			int buffer ;
			stringstream ss(ligne);
			while(ss >> buffer){ 
				Temporary_Transaction.push_back(buffer);
			}
			ss.clear() ;				  
			initial_DataBase.push_back(Temporary_Transaction);
			Temporary_Transaction.clear(); 
		}
	}
	else{
		cerr << "ERROR in reading file" << endl;
	}
}

/// Processing database (delete no frequent items...)
void DataBases::Preprocessing_DataBase(int minsup){
	
	int total_size = 0;
	for ( unsigned int i = 0; i < initial_DataBase.size(); i++){
		for(unsigned int j = 0; j < initial_DataBase[i].size(); j++){
			total_size++;
		}
	}
//	cout << "Total size database (before) = " << total_size << endl;
	
	vector <int> Items; // vector contening all items
	// Get all items of initial database
	for ( unsigned int i = 0; i < initial_DataBase.size(); i++){
		for(unsigned int j = 0; j < initial_DataBase[i].size(); j++){
			if( i == 0 ){ // First transaction => take all of its items
				Items.push_back(initial_DataBase[i][j]);
			} 
			else { // Transactions 2..|D|				
				// if the current item is not found in Items, add it
				if ( std::find(Items.begin(), Items.end(), initial_DataBase[i][j]) == Items.end() ){
					Items.push_back(initial_DataBase[i][j]);
				}
			}
		}
	}	
	sort(Items.begin(), Items.end()); // Lexicographic order on items
	nbrItems = 	Items.size();
	
			
	// ---- Representation <item , set of its transactions> ----
	map < int, VECELE > Table_Verticale; // representation with integer
	vector <int> Trans_;
	// For each item give its transactions
	for(unsigned int k = 0; k < Items.size(); k++){ // for each item
		for ( unsigned int i = 0; i < initial_DataBase.size(); i++){// for each transaction
			if ( std::find(initial_DataBase[i].begin(), initial_DataBase[i].end(), Items[k])!=initial_DataBase[i].end() ){
				Trans_.push_back(i+1);
			}	
		}
		Table_Verticale[Items[k]] = Trans_; // Map with (key :item, value: cover)
		Trans_.clear();
	}
		
	// Frequency of each item
	vector <int> Frequencies;
	map<int, VECELE>::iterator itv; // iterator
	for(itv=Table_Verticale.begin();itv!=Table_Verticale.end(); ++itv){
		Frequencies.push_back(itv->second.size());		
	}		
}

/// Alimenter matrice booléene 
void DataBases::Create_Boolean_Matrix(){
	
	int total_size = 0;
	for ( unsigned int i = 0; i < initial_DataBase.size(); i++){
		for(unsigned int j = 0; j < initial_DataBase[i].size(); j++){
			total_size++;
		}
	}
	//cout << "Total size database (after) = " << total_size << endl;
	
	vector <int> Tmp_Boolean;
	for ( unsigned int i = 0; i < initial_DataBase.size(); i++){ // create a matrix of (n X m) "0"
		for(int u =0; u < nbrItems; u++)
			Tmp_Boolean.push_back(0);				
		Boolean_Base.push_back(Tmp_Boolean);			
		Tmp_Boolean.clear();			
	}		
	
	
	// Mettre à "1" les cases qui correspondent à un item dans la base initiale 
	for ( unsigned int i = 0; i < initial_DataBase.size(); i++){	
		for ( unsigned int j =0; j < initial_DataBase[i].size(); j++){
			Boolean_Base[i][initial_DataBase[i][j]/*-1*/] = 1;
		}
	}	
	
}	

/// Create vertical database with bitset
void DataBases::Create_Vertical_DataBase(){	
	
	int trs0 = Boolean_Base.size(); // nbr transactions
	//cout << "---- here02 ----" << trs0 << endl;
	for(int i = 0; i < Boolean_Base[0].size(); i++){ // for each item
	//cout << "---- here02 ----" << endl;
		boost::dynamic_bitset<> Vertical_bitset(trs0); // a bitset of size |T|
		//cout << "---- here03 ----" << endl;
		for(int j = 0; j < Boolean_Base.size(); j++){
			if (Boolean_Base[j][i] == 1) 
				Vertical_bitset[j] = 1;
			else 
				Vertical_bitset[j] = 0;
		}
		
		Vertical_DataBase.push_back(Vertical_bitset); // add the bitset to structure "vector of bitset"		
	}
	
	
}
